import es
import playerlib
import cPickle
import os.path
import popuplib
import random
import base64


####################################
			#Config Block


#Add here all Soundpaths you want to add to the Favourite Sound Popups. Don't forget the Filetype (.mp3, .wav, ...)
play_sounds = ["myfolder/song1.mp3", "myfolder/song2.mp3", "myfolder/song3.mp3", "myfolder/song4.mp3", "myfolder/song5.mp3", "myfolder/song6.mp3", "myfolder/song7.mp3", "myfolder/song8.mp3", "myfolder/song9.mp3", "myfolder/song10.mp3"]



			#End Config Block
####################################
info = es.AddonInfo()
info.author = "Brainsucker"
info.version = "1.0.0"
info.name = "Join Sound"


logfile = es.getAddonPath("joinsound") + "/soundlog.dat"
soundcounter = 0

def load():
	global sounds
	global soundcounter
	if info.author == base64.decodestring("QnJhaW5zdWNrZXI=\n"):
		es.ServerVar(info.name, info.version).makepublic()
		if not os.path.isfile(logfile):
			create = open(logfile, "w", 1)
			create.flush()
		sounds = {}
		sounds = cPickle.load(open(logfile, "r"))
		
		downloadfiles()
		
		spopup = popuplib.easymenu("soundpopup", "_popup_choice", spopup_choice)
		spopup.settitle("Choose your favourite Sound")
		spopup.addoption("view_sounds", "Show me Soundlist")
		spopup.addoption("random_sound", "Random Sound")
		
		slistpopup = popuplib.easymenu("soundlistpopup", "_popup_choice", slistpopup_choice)
		slistpopup.settitle("Choose a Number to play the Sound")
		
		for line in play_sounds:
			soundcounter += 1
			spopup.addoption(line, "Sound %i" % soundcounter)
			slistpopup.addoption(line, "Sound %i" % soundcounter)
			
		for players in playerlib.getUseridList("#human"):
			steamid = es.getplayersteamid(players)
			if not sounds.has_key(steamid):
				sounds[steamid] = {}
				sounds[steamid]["favsound"] = "random_sound"
				
		cPickle.dump(sounds, open(logfile, "w"))
		
def player_activate(ev):
	rand_sound = random.choice(play_sounds)
	if not ev["es_steamid"] == "BOT" and not ev["es_steamid"] == "STEAM_ID_PENDING":
		if sounds.has_key(ev["es_steamid"]):
			if sounds[ev["es_steamid"]]["favsound"] != "random_sound":
				es.cexec(ev["userid"], "play %s" % sounds[ev["es_steamid"]]["favsound"])
				
			else:
				es.cexec(ev["userid"], "play %s" % rand_sound)
				
		else:
			sounds[ev["es_steamid"]] = {}
			sounds[ev["es_steamid"]]["favsound"] = "random_sound"
			es.cexec(ev["userid"], "play %s" % rand_sound)

def round_end(ev):
	cPickle.dump(sounds, open(logfile, "w"))
	
def es_map_start(ev):
	downloadfiles()
	
def downloadfiles():
	for download in play_sounds:
		es.stringtable('downloadables', 'sound/%s' % download)
		
def player_say(ev):
	if ev["text"].startswith("!"):
		if ev["text"].replace("!", "").lower() == "soundsettings":
			popuplib.send("soundpopup", ev["userid"])

def spopup_choice(userid, choice, popupid):
	if choice == "view_sounds":
		popuplib.send("soundlistpopup", userid)

	else:
		steamid = es.getplayersteamid(userid)
		sounds[steamid]["favsound"] = choice
		popuplib.send("soundpopup", userid)
	
def slistpopup_choice(userid, choice, popupid):
	popuplib.send("soundlistpopup", userid)
	es.cexec(userid, "play %s" % choice)
	
def round_start(ev):
	es.msg("#multi", "Write #green!soundsettings #defaultto choose your favourite Joinsound")
	
def unload():
	closefile = open(logfile, "r", 1)
	closefile.close()
	
	if popuplib.exists("soundlistpopup"):
		popuplib.delete("soundlistpopup")
		
	elif popuplib.exists("soundpopup"):
		popuplib.delete("soundpopup")